#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup(){
	
	ofBackground(0,0,0);
	ofEnableAlphaBlending();
	ofSetVerticalSync(true);
	
}

//--------------------------------------------------------------
void testApp::update(){
	
	seconds = ofGetSeconds();
	minutes = ofGetMinutes();
	hours = ofGetHours();
	
}

//--------------------------------------------------------------
void testApp::draw(){
	
	playSeconds();
	playMinutes();
	playHours();
	
	
}

//--------------------------------------------------------------
void testApp::keyPressed(int key){

}

//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}

void testApp::playSeconds() {
	
	int secondsWidth = ofGetWidth()/60;
	
	secondsColor.r = 0;
	secondsColor.g = 200;
	secondsColor.b = 100 + seconds;
	
	ofPushStyle();
	
	ofSetColor(secondsColor.r, secondsColor.g, secondsColor.b);
	
	for (int i = 0; i< seconds+1; i++) {
		
		ofPushMatrix();
		
		ofTranslate(i*secondsWidth+2, 0, 0);
		ofRect(0, 0, secondsWidth, 30);
		
		ofPushStyle();
		ofSetColor(255, 255, 255, 50);
		ofRect(0, 0, secondsWidth, 10);
		ofPopStyle();
		
		ofPopMatrix();
		
	}
	
	ofPopStyle();
	
}

void testApp::playHours() {
	

	int hoursWidth = ofGetWidth()/12-2;
	int hoursHeight = 100;
	
	int counter;
	
	hoursColor.r = 150;
	hoursColor.g = 0;
	hoursColor.b = 100 + hours*3;
	
	ofPushStyle();
	
	ofSetColor(hoursColor.r, hoursColor.g, hoursColor.b);
	
	//clamp our hours at 
	
	if (hours > 12) {
		hours-=12;
	}
	
	for (int i = 0; i < hours; i++) {
		
		
		ofPushMatrix();
		
		ofTranslate(i*hoursWidth+2*i, ofGetHeight()-hoursHeight, 0);
		ofRect(0, 0, hoursWidth, hoursHeight);
		
		ofPushStyle();
		ofSetColor(255, 255, 255, 50);
		ofRect(0, 0,hoursWidth, 20);
		ofPopStyle();
		
		ofPopMatrix();
		
	}
	
	
	
	ofPopStyle();
	
	
	
}


void testApp::playMinutes() {
	
	int minutesWidth = ofGetWidth()/10-10;
	
	int columns= 10;
	int rows = 0;
	int current = 0;
	
	minutesColor.r = 0;
	minutesColor.g = 150 - seconds;
	minutesColor.b = 160 + seconds;
	
	//  Take Two 
	//	The Hack actually works, first failed attempt below.
		
	int rowMath = floor(minutes/10);
	rows = rowMath;
	
	
	
	for (int i = 0; i < columns; i++) {
		for (int j = 0; j< rows; j++ ) {
			
		ofPushMatrix();
		ofPushStyle();
			
		
		ofSetColor(minutesColor.r, minutesColor.g, minutesColor.b);
		ofTranslate(minutesWidth * i +i*10+ofGetWidth()/130, minutesWidth/2 +minutesWidth *j+j*10 , 0);
		ofRect(0, 0, minutesWidth, minutesWidth);
		
		ofPushStyle();
		ofSetColor(255, 255, 255, 50);
		ofRect(0, 0, minutesWidth, 15+i);
		ofPopStyle();
		
		ofPopStyle();
		ofPopMatrix();
			
			
		}
				
	}
	
	if (minutes-(rows*10)>0) {
		current= minutes-(rows*10);
		
		for (int i = 0; i< current; i++){
			
		
			ofPushMatrix();
			ofPushStyle();
			
			
			ofSetColor(minutesColor.r, minutesColor.g, minutesColor.b);
			ofTranslate(minutesWidth * i +i*10 +ofGetWidth()/130, minutesWidth/2 +minutesWidth *rows + rows * 10 , 0);
			ofRect(0, 0, minutesWidth, minutesWidth);
			
			ofPushStyle();
			ofSetColor(255, 255, 255, 50);
			ofRect(0, 0, minutesWidth, 15+i);
			ofPopStyle();
			
			ofPopStyle();
			ofPopMatrix();
			
		}
		
		
	}
	

	// uncomment to see how many rows and columns we are calculating.
	//ofDrawBitmapString("rows: "+ofToString(rows)+" mins: "+ofToString(minutes)+" current :"+ofToString(current) , 200, 200);

	
	// Nested Loop Hack 
	// Size of for loop determines num of total minutes 
	// Counter iterates through and augments ypos at tenth num then resets
	
	// I am interested in suggestions on how to improve this piece of code its bulky and inefficient.
	
	//variables of the hack
//	int xpos;
//	int ypos = minutesWidth/2;
//	int counter=0;
	
//	for (int i = 1; i<minutes ; i++) {
//		
//		xpos = 20+ counter * minutesWidth + counter * 5;
//		counter++;
//		
//		
//		if (counter == 11) {
//			counter = 0;
//			ypos += minutesWidth + 10;
//			xpos = 20+ counter * minutesWidth+counter * 10;
//		}
//		
//		
//		ofPushMatrix();
//		ofPushStyle();
//		
//		ofSetColor(minutesColor.r, minutesColor.g, minutesColor.b);
//		ofTranslate(xpos, ypos , 0);
//		ofRect(0, 0, minutesWidth, minutesWidth);
//		
//		ofPushStyle();
//		ofSetColor(255, 255, 255, 50);
//		ofRect(0, 0, minutesWidth, 10+i);
//		ofPopStyle();
//		
//		ofPopStyle();
//		ofPopMatrix();
//		
//	}

}

	
	
